<template>
	<div ref="paymentCard">
		<pay-result :state="state"
					v-if="state"
					@close="payResultModalClose">
		</pay-result>
		<div class="col">
			<div class="row">
				<card-form v-model="sum"
						   :component="component"
						   @hideForm="$emit('hideForm')"
						   @return-to-loan="$emit('return-to-loan')"
						   ref="card">
				</card-form>
			</div>

			<div v-if="payResult && payResult.success && showCardForm" class="success-block">
				Спасибо! Оплата осуществлена успешно.
			</div>
			<div v-if="payResult && !payResult.success && showCardForm" class="error-block">
				К сожалению не удалось осуществить оплату, попробуйте еще раз.
			</div>
		</div>
	</div>
</template>

<script>
	import SumAndOrder from '@/components/Pay/SumAndOrder';
	import WarningMessage from '@/components/AuxiliaryWindows/WarningMessage';
	import CardForm from './CardForm';
	import PayResult from '@/components/Modals/PayResult';
	import AdditionalServices from '@/components/Chunks/AdditionalServices';

	export default {
		name: 'BankCard',
		components: {AdditionalServices, SumAndOrder, WarningMessage, CardForm, PayResult},
		inject: ['ActiveLoan'],
		props: {
			autosubmit: {
				required: false,
				default: false,
			},
			iFrameUrl: {
				type: String,
				default: '',
			},
			component: {
				type: String,
				required: false,
				default: '',
			},
		},
		data() {
			return {
				sum: null,
				type: null,
				urlForIframe: this.iFrameUrl,
				payResult: null,
				frameHeight: '1450px',
				paymentDone: false,
				showCardForm: false,
				/**
				 * payment result state
				 * 1 - ok
				 * 2 - error
				 */
				state: 0,
			};
		},
		computed: {
			blocker() {
				return !this.$pdl.canPay;
			},
			title() {
				return this.paymentDone ? 'Статус платежа' : 'Оплата';
			},
		},

		created() {
			// window.addEventListener('message', this.postMessage, {
			//     passive: true
			// });

			this.sum = this.$pay.paymentAmount || this.$payment.totalDebt;

			if (this.autosubmit) {
				this.$pay.showPaymentForm = false;
				this.pay();
			}
		},

		mounted() {
			this.$helpers.scroll(this.$refs.paymentCard.$el);
		},

		beforeDestroy() {
			window.removeEventListener('message', this.postMessage);
		},

		methods: {

			postMessage(message) {
				// приходит после того, как прошла оплата.
				console.log('Card::postMessage', message);
				this.payResult = message.data;

				switch (message.origin) {
					case 'https://webbankir.com':
						try {
							const parse = JSON.parse(message.data);
							this.$pay.showPaymentFormHeight = parse.height;
						} catch (e) {
							this.$pay.showPaymentFormHeight = 600;
						}
						this.$helpers.scroll(this.$refs.iframe);
						break;

					default:
						this.payResult = message.data;
						this.$helpers.scroll(this.$refs.iframe);
						break;
				}

				if (typeof message.data === 'object') {
					if (this.payResult.success) {
						if (this.$pay.paymentType === 'credit_rating') {
							this.$emit('success');
						}
					}
				}

			},

			payResultModalClose() {
				if (this.ActiveLoan)
					this.ActiveLoan.componentToShow = '';

				this.$nextTick(() => {
					window.scrollTo(0, 0);
				});
			},

			async closePaymentResultModal() {
				this.$modal.hide('payment-result');
				this.$events.$emit('hidePaymentForm');
				this.updateLoan();
			},
			async updateLoan() {
				this.$store.commit('AJAX_LOADING', true);
				this.$helpers.scroll(this.$root.$el);
				// update loan status
				const promises = [];
				promises.push(this.$store.dispatch('GET_LOAN_PDL'));
				promises.push(this.$store.dispatch('GET_LOAN_POS'));
				await Promise.all(promises);
				this.$store.commit('AJAX_LOADING', false);
				this.$helpers.noscroll(false);
			},

			async pay() {
				this.BUTTON_LOADING(true);
				try {
					console.log('payment');
					this.$store.dispatch('createPayment');
					// const {data} = await this.$store.dispatch('getLinkToPayWithMainMethods', {
					//     payMethod: 'card',
					//     sum: this.sum,
					//     type: 1,
					//     source: 4,
					// });
					this.$emit('payment-data-ready', data);

					this.$backend.log({
						action: 'paymentTry',
						userid: this.$user.id,
						userlogin: this.$user.login,
						method: 'card',
						step: 1,
					});

					this.BUTTON_LOADING(false);
					// if (data.data.url) {
					//     /**
					//      * иницилизация фрейма платежного аггрегатора
					//      * @type {boolean}
					//      */
					//     this.$pay.process = true;
					//     this.$pay.showPaymentForm = true;
					//     this.urlForIframe = data.data.url
					//
					//     this.$nextTick(() => {
					//         this.$helpers.scroll(this.$refs.iframe);
					//     });
					//
					//     /**
					//      * ждем результаты оплаты
					//      */
					//     if (!this.$pay.paymentEventInit) {
					//         window.addEventListener('message', (message) => {
					//             this.$store.commit('PAYMENT_EVENT_INIT', true);
					//             // приходит после того, как прошла оплата.
					//             console.log('payment Message:', message);
					//             this.$pay.showPaymentForm = true;
					//             switch (message.origin) {
					//                 default:
					//                     // @todo uncomment after recursion fix
					//                     // this.$backend.log({
					//                     //       action: 'paymentTry',
					//                     //       userid: this.$user.id,
					//                     //       userlogin: this.$user.login,
					//                     //       method: 'card',
					//                     //       step: 2,
					//                     //       message: message.data
					//                     // });
					//                     this.payResult = message.data;
					//                     if (typeof message.data === "object") {
					//                         if (this.payResult.success) {
					//                             switch (this.$pay.paymentType) {
					//                                 case 'credit_rating':
					//                                     this.$emit('success');
					//                                     break;
					//                                 case 'AMNESTY_2019':
					//                                     this.$emit('success');
					//                                     break;
					//                                 case 'prolongation_deposit':
					//                                     this.$toastr.success('Доп.соглашение о пролонгации оплачено.', 'Успешно');
					//                                     try {
					//                                         this.ActiveLoan.initUpdate({
					//                                             pdl: true,
					//                                             calc: true
					//                                         });
					//                                     } catch (e) {
					//                                     }
					//                                     break;
					//                                 case 'installment_deposit':
					//                                     this.$toastr.success('Доп.соглашение о рассрочке оплачено.', 'Успешно');
					//                                     try {
					//                                         this.ActiveLoan.initUpdate({
					//                                             pdl: true
					//                                         });
					//                                     } catch (e) {
					//                                     }
					//
					//                                     /**
					//                                      * Меняем статус на оплачено, чтобы скрыть блок о необходимости оплаты
					//                                      */
					//                                     this.$store.commit('SET_PAY_STATUS', {
					//                                         type: 'installment',
					//                                         status: 'payed'
					//                                     });
					//
					//                                     break;
					//                                 default:
					//                                     this.$toastr.success(
					//                                         'Ваш платеж принят в обработку.',
					//                                         'Оплата прошла успешно'
					//                                     );
					//                                     try {
					//                                         this.ActiveLoan.initUpdate({
					//                                             pdl: true
					//                                         });
					//                                     } catch (e) {
					//                                     }
					//                                     break;
					//                             }
					//                             this.paymentDone = false;
					//                             this.state = 1;
					//                             this.$pay.process = false;
					//                             this.$nextTick(() => {
					//                                 this.$modal.show('payResult');
					//                             })
					//                         } else {
					//                             this.state = 2;
					//                             this.paymentDone = false;
					//                             this.$pay.process = false;
					//                             this.$nextTick(() => {
					//                                 this.$modal.show('payResult');
					//                             })
					//                         }
					//                     }
					//
					//                     break;
					//             }
					//         }, false);
					//     }
					//
					// } else {
					this.showCardForm = true;
					// }
				} catch (e) {
					this.$toastr.error('Не удалось получить данные для оплаты', 'Ошибка');
					this.$emit('payment-data-error', e);
					if (Array.isArray(e.errors)) {
						this.$backend.log({
							payment_error: JSON.stringify(e.errors),
							user_login: this.$user.login,
							user_id: this.$user.id,
							payment_data: this.$pay.lastPaymentData,
						});
					}
					this.BUTTON_LOADING(false);
					this.$pay.showPaymentForm = false;
					this.$pay.process = false;
					// errorRepay(e.errors[0].code, this.$store)
				}
			},
		},
	};
</script>

<style scoped lang="scss">
	@media all and (max-width: 690px) {
		.pay-button__container {
			text-align: center;
		}
	}
</style>
